import { jsx, jsxs } from "react/jsx-runtime";
import { useMemo, useState } from "react";
import { ArrayTable } from "@tachybase/components";
import { uid, useForm } from "@tachybase/schema";
import { omit, set } from "lodash";
import cloneDeep from "lodash/cloneDeep";
import { useTranslation } from "react-i18next";
import { useAPIClient, useRequest } from "../../api-client/index.mjs";
import { useCollectionParentRecordData } from "../../data-source/index.mjs";
import { RecordProvider, useRecord } from "../../record-provider/index.mjs";
import { ActionContextProvider, SchemaComponent, useActionContext, useCompile } from "../../schema-component/index.mjs";
import { useCancelAction } from "../action-hooks.mjs";
import { useCollectionManager_deprecated } from "../hooks/index.mjs";
import { useResourceActionContext, useResourceContext } from "../ResourceActionProvider.mjs";
import * as __WEBPACK_EXTERNAL_MODULE__components_index_mjs_99c14d58__ from "./components/index.mjs";
const getSchema = (schema, record, compile, getContainer)=>{
    var _record___parent;
    if (!schema) return;
    const properties = cloneDeep(schema.properties);
    properties.name['x-disabled'] = true;
    if (true === schema.hasDefaultValue) {
        properties['defaultValue'] = cloneDeep(schema.default.uiSchema);
        properties['defaultValue']['title'] = compile('{{ t("Default value") }}');
        properties['defaultValue']['x-decorator'] = 'FormItem';
    }
    return {
        type: 'object',
        properties: {
            [uid()]: {
                type: 'void',
                'x-component': 'Action.Drawer',
                'x-decorator': 'Form',
                'x-decorator-props': {
                    useValues (options) {
                        return useRequest(()=>Promise.resolve({
                                data: cloneDeep(schema.default)
                            }), options);
                    }
                },
                title: "".concat(compile(null == (_record___parent = record.__parent) ? void 0 : _record___parent.title), " - ").concat(compile('{{ t("Override field") }}')),
                properties: {
                    summary: {
                        type: 'void',
                        'x-component': 'FieldSummary',
                        'x-component-props': {
                            schemaKey: schema.name
                        }
                    },
                    ...properties,
                    description: {
                        type: 'string',
                        title: '{{t("Description")}}',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input.TextArea'
                    },
                    footer: {
                        type: 'void',
                        'x-component': 'Action.Drawer.Footer',
                        properties: {
                            action1: {
                                title: '{{ t("Cancel") }}',
                                'x-component': 'Action',
                                'x-component-props': {
                                    useAction: '{{ useCancelAction }}'
                                }
                            },
                            action2: {
                                title: '{{ t("Submit") }}',
                                'x-component': 'Action',
                                'x-component-props': {
                                    type: 'primary',
                                    useAction: '{{ useOverridingCollectionField }}'
                                }
                            }
                        }
                    }
                }
            }
        }
    };
};
const useOverridingCollectionField = ()=>{
    const form = useForm();
    const { refreshCM } = useCollectionManager_deprecated();
    const ctx = useActionContext();
    const { refresh } = useResourceActionContext();
    const { resource } = useResourceContext();
    return {
        async run () {
            await form.submit();
            const values = cloneDeep(form.values);
            const data = omit(values, [
                'key',
                'uiSchemaUid',
                'collectionName',
                'autoCreateReverseField',
                'uiSchema.x-uid',
                'reverseField',
                'reverseKey',
                'parentKey'
            ]);
            await resource.create({
                values: data
            });
            ctx.setVisible(false);
            await form.reset();
            refresh();
            await refreshCM();
        }
    };
};
const OverridingCollectionField = (props)=>{
    const record = useRecord();
    const parentRecordData = useCollectionParentRecordData();
    return /*#__PURE__*/ jsx(OverridingFieldAction, {
        item: record,
        parentItem: parentRecordData,
        ...props
    });
};
const getIsOverriding = (currentFields, record)=>{
    const flag = currentFields.find((v)=>v.name === record.name);
    return flag;
};
const OverridingFieldAction = (props)=>{
    const { scope, getContainer, item: record, parentItem: parentRecord, children, currentCollection } = props;
    const { target, through } = record;
    const { getInterface, getCurrentCollectionFields, getChildrenCollections, collections } = useCollectionManager_deprecated();
    const [visible, setVisible] = useState(false);
    const [schema, setSchema] = useState({});
    const api = useAPIClient();
    const { t } = useTranslation();
    const compile = useCompile();
    const getFilterCollections = (filterKey)=>{
        var _getChildrenCollections;
        const childCollections = filterKey && (null == (_getChildrenCollections = getChildrenCollections(filterKey)) ? void 0 : _getChildrenCollections.map((v)=>v.name).concat([
            filterKey
        ]));
        return childCollections;
    };
    const [data, setData] = useState({});
    const currentFields = getCurrentCollectionFields(currentCollection);
    const disabled = getIsOverriding(currentFields, record);
    const currentCollections = useMemo(()=>collections.map((v)=>({
                label: compile(v.title),
                value: v.name
            })), []);
    return /*#__PURE__*/ jsx(RecordProvider, {
        record: {
            ...record,
            collectionName: parentRecord.name
        },
        parent: parentRecord,
        children: /*#__PURE__*/ jsxs(ActionContextProvider, {
            value: {
                visible,
                setVisible
            },
            children: [
                /*#__PURE__*/ jsx("a", {
                    disabled: disabled,
                    onClick: async ()=>{
                        if (!disabled) {
                            const { data } = await api.resource('collections.fields', record.collectionName).get({
                                filterByTk: record.name,
                                appends: [
                                    'reverseField'
                                ]
                            });
                            setData(null == data ? void 0 : data.data);
                            const interfaceConf = getInterface(record.interface);
                            const defaultValues = cloneDeep(null == data ? void 0 : data.data) || {};
                            if (!(null == defaultValues ? void 0 : defaultValues.reverseField)) {
                                var _interfaceConf_default;
                                defaultValues.autoCreateReverseField = false;
                                defaultValues.reverseField = null == (_interfaceConf_default = interfaceConf.default) ? void 0 : _interfaceConf_default.reverseField;
                                set(defaultValues.reverseField, 'name', "f_".concat(uid()));
                                set(defaultValues.reverseField, 'uiSchema.title', record.__parent.title);
                            }
                            const schema = getSchema({
                                ...interfaceConf,
                                default: defaultValues
                            }, record, compile, getContainer);
                            setSchema(schema);
                            setVisible(true);
                        }
                    },
                    children: children || t('Override')
                }),
                /*#__PURE__*/ jsx(SchemaComponent, {
                    schema: schema,
                    components: {
                        ...__WEBPACK_EXTERNAL_MODULE__components_index_mjs_99c14d58__,
                        ArrayTable: ArrayTable
                    },
                    scope: {
                        getContainer,
                        useOverridingCollectionField,
                        useCancelAction: useCancelAction,
                        showReverseFieldConfig: !(null == data ? void 0 : data.reverseField),
                        createOnly: true,
                        override: true,
                        isOverride: true,
                        targetScope: {
                            target: getFilterCollections(target),
                            through: getFilterCollections(through)
                        },
                        collections: currentCollections,
                        ...scope
                    }
                })
            ]
        })
    });
};
export { OverridingCollectionField, OverridingFieldAction };
